package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.PtovtaAgenciaDAO;
import com.rjconsultores.ventaboletos.entidad.PtovtaAgencia;
import com.rjconsultores.ventaboletos.entidad.InstiFinanceira;

@Repository("ptovtaAgenciaBancariaDAO")
public class PtovtaAgenciaHibernateDAO extends GenericHibernateDAO<PtovtaAgencia, Integer>
	implements PtovtaAgenciaDAO {

    @Autowired
    public PtovtaAgenciaHibernateDAO(
            @Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PtovtaAgencia> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.addOrder(Order.asc("numagencia"));
        
        return c.list();
    }

    public List<PtovtaAgencia> buscar(String numagencia) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
        c.add(Restrictions.eq("numagencia", numagencia));
        

        return c.list();
    }
    
    public void borrarFisico(PtovtaAgencia pto) {
        String hql = " delete from PtovtaAgencia "
                + " where ptovtaAgenciaId = " + pto.getPtovtaAgenciaId();
        Query sq = getSession().createQuery(hql);
        sq.executeUpdate();
    }
}

